local mod = RW:Boss("Gunship Battle", "Icecrown Citadell", "Icecrown Citadell", "The Entryway")
local L

-- 3.3?
if not QueryQuestsCompleted then return end

---------------------------
-- Variables
local wBelow
local wVeteran

---------------------------
-- Init
function mod:OnRegister()
	L = mod:RegisterLocale(self:GetName(), "enUS", true)
	if L then
		L.name = "Gunship Battle"
	
		L.YellPull1 = "What is that? Something approaching in the distance."
		L.YellPull2 = "ALLIANCE GUNSHIP! ALL HAND ON DECK!"
		
		L.health_frames = "Show stack frame for "..GetSpellInfo(72306)
	end
	L = mod:GetLocale()
	mod.L = L
	
	mod:SetTrigger(L.YellPull1, L.YellPull2, 37200)
	mod:SetWin()
	
	mod:SetDelay(30)
	
	self:AddBoolOption("HealthFrame", L.health_frames, nil, nil, select(3, GetSpellInfo(72306)))
	
	wBelow		= self:CastWarning(69705)
	
	iExp		= self:Icon("SKULL", 71188, false, nil, "CROSS", "SQUARE")
end

---------------------------
-- Locals
local belowSpamm
local furyStacks


local function updateStack()
	return furyStacks, 25
end

---------------------------
-- Start

function mod:OnEngage(trigger)
	self:Track("Below", 69705)
	self:Track("Fury", 72306, 72307, 69638, 69637, 72308)
	
	belowSpamm = 0
	furyStacks = 1
	
	if self.db.profile.HealthFrame then
		self:SendMessage("RW_AddHealthFrame", updateStack, GetSpellInfo(72306), select(3, GetSpellInfo(72306)), "STACK")
	end
end

function mod:Below(event, args)
	if event == "SPELL_AURA_APPLIED" then
		if GetTime() - belowSpamm > 2 then
			wBelow:Show()
			belowSpamm = GetTime()
		end
	end
end

function mod:Fury(event, args)
	if event == "SPELL_AURA_APPLIED" or event == "SPELL_AURA_APLIED_DOESE" then
		furyStacks = args.amount or 1
	end
end
