local mod = RW:Boss("Scourgelord Tyrannus", "Pit of Saron", "PartyWOTLK", "Pit of Saron")
local L

-- 3.3?
if not QueryQuestsCompleted then return end

---------------------------
-- Variables
local tSmashCD, tBrandDur, tPowerDur
local wHoarFrost, wBrand, wPower
local mBrand
local iHoarFrost, iBrand

---------------------------
-- Init

function mod:OnRegister()
	L = mod:RegisterLocale(self:GetName(), "enUS", true)
	if L then
		L.name = "Scourgelord Tyrannus"
		L.YellEngage = "Ha, such an amusing gesture from the rabble. When I have finished with you, my master's blade will feast upon your souls. Die"
		
		L.frost_target = "^%%s gazes at (%w+) and readies an icy attack!"
		
		L.debug_frost = "%s gazes at Sariah and redies an icy attack!"
	end
	L = mod:GetLocale()
	self.L = L
	
	self:SetTrigger(L.YellEngage, 36658)
	self:SetWin()
	
	tSmashCD = self:CDTimer(30, 69627)
	tBrandDur = self:DurTargetTimer(8, 69172)
	tPowerDur = self:DurTimer(10, 69629)
	
	wHoarFrost = self:RunawayWarning(69246)
	wBrand = self:Warning(69172)
	wPower = self:RunawayWarning(69629, nil, nil, nil, false)
	
	mBrand = self:TargetMessage(69172)
	
	iHoarFrost = self:Icon("SKULL", 69246)
	iBrand = self:Icon("CROSS", 69172)
end

---------------------------
-- Locals

---------------------------
-- Start

function mod:OnEngage(trigger)
	self:Track("HoarFrost", 69246, 69245, 68645)
	self:Track("Smash", 69627, 69155)
	self:Track("Brand", 69172, 69189, 69190)
	self:Track("Power", 69629, 69167)
	
	self:YellTrack("DebugFrost", L.debug_frost)
	
	tSmashCD:Start()
end

function mod:HoarFrost(event, args)
	if event == "SPELL_AURA_REMOVED" then
		iHoarFrost:Hide(args.dName)
	end
end

function mod:Smash(event, args)
	if event == "SPELL_CAST_SUCCESS" then
		tSmashCD:Start()
	end
end

function mod:Brand(event, args)
	if event == "SPELL_AURA_APPLIED" then
		if args:IsPlayer() then
			wBrand:Show()
		end
		tBrandDur:Start(args.dName)
		iBrand:Show(args.dName)
		mBrand:Show(args.dName)
	end
end

function mod:Power(event, args)
	if event == "SPELL_CAST_START" then
		wPower:Show()
		
	elseif event == "SPELL_CAST_SUCCESS" then
		tPowerDur:Start()
	end
end

function mod:CHAT_MSG_RAID_BOSS_EMOTE(event, msg, name)
	local target = select(3, msg:find(L.frost_target))
	if target then
		if target == self.pName then
			wHoarFrost:Show()
		end
		iHoarFrost:Show(target)
	end
end

function mod:DebugFrost(event, message, name)
	local target = select(3, msg:find(L.frost_target))
	if target then self:Msg("frost target: ", target) else self:Msg("frost target: ", "none") end
end
